Broadcast = {}
Broadcast_mp = Class(Broadcast)

function Broadcast:new()
    self.__index = self
end

function onStart()
    Broadcast:onStart()
end

function Broadcast:onStart()
    if g_currentMission.connectedToDedicatedServer then
        self:readBroadcast()
        addTimer(1 * 1000, "tick", self)
    end
end

function Broadcast:tick()
    self:readBroadcast(true)
    addTimer(1 * 1000, "tick", self)
end

function Broadcast:readBroadcast(broadcast)
    local path = getUserProfileAppPath()
    local file = path .. "/modSettings/vg_broadcast.xml"

    if fileExists(file) == false then
        return
    end

    local xmlFile = loadXMLFile("Message", file)

    if xmlFile == nil then
        return
    end

    -- Get the message and type
    local message = getXMLString(xmlFile, "Message")
    local messageType = getXMLString(xmlFile, "Message#type")

    -- Check if message exists and is not empty
    if message == nil or message == "" then
        return
    end

    -- remove message and save (unable to delete the file)
    setXMLString(xmlFile, "Message", "")
    saveXMLFile(xmlFile)
    delete(xmlFile)

    if broadcast == false or broadcast == nil then
        return
    end

    if messageType == "console" then
        self:printConsole(message)
    elseif messageType == "chat" then
        if g_server ~= nil then
            local chatEvent = ChatEvent.new(message, "Broadcast", g_currentMission:getFarmId(),
                g_currentMission.playerUserId)
            g_server:broadcastEvent(chatEvent)
        end
    end
end

function Broadcast:printConsole(text, ...)
    Logging.info(text, ...)
end

FSBaseMission.onStartMission = Utils.appendedFunction(FSBaseMission.onStartMission, onStart)
